// ISP_SDK_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ISP_SDK_Example.h"
#include "ISP_SDK_ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

double CCDData[2448];
/////////////////////////////////////////////////////////////////////////////
// CISP_SDK_ExampleDlg dialog

CISP_SDK_ExampleDlg::CISP_SDK_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CISP_SDK_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CISP_SDK_ExampleDlg)
	m_strDeviceNum = _T("");
	m_strModuleNo = _T("");
	m_strCCDSize = _T("");
	m_strSliceNum = _T("");
	m_strSerialNo = _T("");
	m_strFrameCnt = _T("");
	m_strMax1 = _T("");
	m_strMax2 = _T("");
	m_strMax3 = _T("");
	m_strMaxCCD = _T("");
	m_strMin1 = _T("");
	m_strMin2 = _T("");
	m_strMin3 = _T("");
	m_strMinCCD = _T("");
	m_intAvgNum = 0;
	m_intCCDGain = 0;
	m_intExpTime = 0;
	m_intOptBlack = 0;
	m_boolETC = FALSE;
	m_strFrameTime = _T("");
	m_strMaxDarkSub = _T("");
	m_strMaxTvR = _T("");
	m_strMinDarkSub = _T("");
	m_strMinTvR = _T("");
	m_intPixel = 0;
	m_strWav = _T("");
	m_str360 = _T("");
	m_str555 = _T("");
	m_str830 = _T("");
	m_struv = _T("");
	m_strxy = _T("");
	m_strCCT = _T("");
	m_strCRIa = _T("");
	m_strMinCalib = _T("");
	m_strMaxCalib = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CISP_SDK_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CISP_SDK_ExampleDlg)
	DDX_Text(pDX, labelDeviceNum, m_strDeviceNum);
	DDX_Text(pDX, LabelModuleNo, m_strModuleNo);
	DDX_Text(pDX, LabelCCDSize, m_strCCDSize);
	DDX_Text(pDX, LabelSliceNum, m_strSliceNum);
	DDX_Text(pDX, LabelSerialNo, m_strSerialNo);
	DDX_Text(pDX, labelMax1, m_strMax1);
	DDX_Text(pDX, LabelMax2, m_strMax2);
	DDX_Text(pDX, labelMax3, m_strMax3);
	DDX_Text(pDX, labelMaxCCD, m_strMaxCCD);
	DDX_Text(pDX, labelMin1, m_strMin1);
	DDX_Text(pDX, labelMin2, m_strMin2);
	DDX_Text(pDX, labelMin3, m_strMin3);
	DDX_Text(pDX, labelMinCCD, m_strMinCCD);
	DDX_Text(pDX, editAvgNum, m_intAvgNum);
	DDX_Text(pDX, editCCDGain, m_intCCDGain);
	DDX_Text(pDX, editExpTime, m_intExpTime);
	DDX_Text(pDX, editOptBlack, m_intOptBlack);
	DDX_Check(pDX, checkETC, m_boolETC);
	DDX_Text(pDX, labelFrameTime, m_strFrameTime);
	DDX_Text(pDX, labelMaxDarkSub, m_strMaxDarkSub);
	DDX_Text(pDX, labelMaxTvR, m_strMaxTvR);
	DDX_Text(pDX, labelMinDarkSub, m_strMinDarkSub);
	DDX_Text(pDX, labelMinTvR, m_strMinTvR);
	DDX_Text(pDX, editPixel, m_intPixel);
	DDV_MinMaxInt(pDX, m_intPixel, 0, 1391);
	DDX_Text(pDX, labelWav, m_strWav);
	DDX_Text(pDX, labelSpectrum360, m_str360);
	DDX_Text(pDX, labelSpectrum555, m_str555);
	DDX_Text(pDX, labelSpectrum830, m_str830);
	DDX_Text(pDX, labeluv, m_struv);
	DDX_Text(pDX, labelxy, m_strxy);
	DDX_Text(pDX, labelCCT, m_strCCT);
	DDX_Text(pDX, labelCRIa, m_strCRIa);
	DDX_Text(pDX, labelCalibMin, m_strMinCalib);
	DDX_Text(pDX, labelCalibMax, m_strMaxCalib);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CISP_SDK_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CISP_SDK_ExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(btnInitDevice, OnbtnInitDeviceClick)
	ON_BN_CLICKED(btnModuleNo, OnbtnModuleNoClick)
	ON_BN_CLICKED(btnAddDevice, OnbtnAddDeviceClick)
	ON_BN_CLICKED(btnCCDSize, OnbtnCCDSizeClick)
	ON_BN_CLICKED(btnSliceNum, OnbtnSliceNumClick)
	ON_BN_CLICKED(btnStartDevice, OnbtnStartDeviceClick)
	ON_BN_CLICKED(btnStop, OnbtnStopClick)
	ON_BN_CLICKED(btnRemove, OnbtnRemoveClick)
	ON_BN_CLICKED(btnUnInit, OnbtnUnInitClick)
	ON_BN_CLICKED(radioWorkMode, OnradioWorkModeClick)
	ON_BN_CLICKED(radioExtTrig, OnradioExtTrigClick)
	ON_BN_CLICKED(btnSetExpTime, OnbtnSetExpTimeClick)
	ON_BN_CLICKED(btnGain, OnbtnGainClick)
	ON_BN_CLICKED(btnOptBlack, OnbtnOptBlackClick)
	ON_BN_CLICKED(btnAvgNum, OnbtnAvgNumClick)
	ON_BN_CLICKED(checkETC, OncheckETCClick)
	ON_BN_CLICKED(btnGrabOne, OnbtnGrabOneClick)
	ON_BN_CLICKED(btnGetData, OnbtnGetDataClick)
	ON_BN_CLICKED(btnInstallCallBack, OnbtnInstallCallBackClick)
	ON_BN_CLICKED(btnStartGrab, OnbtnStartGrabClick)
	ON_BN_CLICKED(btnStopGrab, OnbtnStopGrabClick)
	ON_BN_CLICKED(btnSetDrk, OnbtnSetDrkClick)
	ON_BN_CLICKED(btnSetRef, OnbtnSetRefClick)
	ON_BN_CLICKED(btnGetWav, OnbtnGetWavClick)
	ON_BN_CLICKED(btnSpectrum, OnbtnSpectrumClick)
	ON_BN_CLICKED(btnCIE, OnbtnCIEClick)
	ON_BN_CLICKED(btnCRI, OnbtnCRIClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CISP_SDK_ExampleDlg message handlers

BOOL CISP_SDK_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_strDeviceNum.Format("%d",0);
	

	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CISP_SDK_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CISP_SDK_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CISP_SDK_ExampleDlg::OnbtnInitDeviceClick() 
{
	// TODO: Add your control notification handler code here
	int DeviceNum;
    DeviceNum = MTUCISP_InitDevice( );
	m_strDeviceNum.Format("%d",DeviceNum);

	UpdateData(FALSE);
	
}

void CISP_SDK_ExampleDlg::OnbtnModuleNoClick() 
{
	char ModuleNo[32],SerialNo[32];
	// TODO: Add your control notification handler code here
	if (MTUCISP_GetDeviceModuleNoSerialNo(1, ModuleNo, SerialNo) == 1)
	{
		m_strModuleNo = CString(ModuleNo);
		m_strSerialNo = CString(SerialNo);
	}
	else
	{
		m_strModuleNo = "_";
		m_strSerialNo = "_";
	}
	UpdateData(FALSE);
	
}

void CISP_SDK_ExampleDlg::OnbtnAddDeviceClick() 
{
	// TODO: Add your control notification handler code here
	if (MTUCISP_AddDeviceToWorkingSet(1) == 1) 
	{
		SetDlgItemText(labelAddInfo,"Add OK");
	}
	else
	{
		SetDlgItemText(labelAddInfo,"Add Failed");
	}
}

void CISP_SDK_ExampleDlg::OnbtnCCDSizeClick() 
{
	// TODO: Add your control notification handler code here
	int CCDSize[2];
	if (MTUCISP_GetDeviceCCDSize(1,CCDSize) == 1)
	{
		m_strCCDSize.Format("%dx%d",CCDSize[1],CCDSize[0]);
	}
	else
	{
		m_strCCDSize = "0x0";
	}
	UpdateData(false);
	
}

void CISP_SDK_ExampleDlg::OnbtnSliceNumClick() 
{
	// TODO: Add your control notification handler code here
	int SliceNum;
	SliceNum = MTUCISP_GetDeviceSpectrometerNum(1);
	if (SliceNum > 0)
	{
		m_strSliceNum.Format("%d",SliceNum);	
	}
	else
	{
		m_strSliceNum = "No Slice";
	}
	UpdateData(false);
}

void CISP_SDK_ExampleDlg::OnbtnStartDeviceClick() 
{
	// TODO: Add your control notification handler code here
	if (MTUCISP_StartDeviceEngine( ) == 1)
	{
		SetDlgItemText(labelStartDevice,"Started");
	}
	else
	{
		SetDlgItemText(labelStartDevice,"failed");
	}
}

void CISP_SDK_ExampleDlg::OnbtnStopClick() 
{
	// TODO: Add your control notification handler code here
	if( MTUCISP_StopDeviceEngine( ) ==1 )
	{
		SetDlgItemText(labelStopInfo,"Stopped");
	}
	else
	{
		SetDlgItemText(labelStopInfo,"Failed");
	}
}

void CISP_SDK_ExampleDlg::OnbtnRemoveClick() 
{
	// TODO: Add your control notification handler code here
	if( MTUCISP_RemoveDeviceFromWorkingSet( 1 ) == 1 )
	{
		SetDlgItemText(labelRemoveInfo,"Removed");
	}
	else
	{
		SetDlgItemText(labelRemoveInfo,"Failed");
	}
	
}

void CISP_SDK_ExampleDlg::OnbtnUnInitClick() 
{
	// TODO: Add your control notification handler code here
	if( MTUCISP_UnInitDevice( ) == 1 )
	{
		SetDlgItemText(labelUnInitInfo,"UnInited");
	}
	else
	{
		SetDlgItemText(labelUnInitInfo,"Failed");
	}
	
}

void CISP_SDK_ExampleDlg::OnradioWorkModeClick() 
{
	// TODO: Add your control notification handler code here
	int WorkMode;
	WorkMode = 0;
	if (MTUCISP_SetDeviceWorkMode(1, WorkMode) == 1)
	{
		
	}
}

void CISP_SDK_ExampleDlg::OnradioExtTrigClick() 
{
	// TODO: Add your control notification handler code here
	int WorkMode;
	WorkMode = 1;
	if (MTUCISP_SetDeviceWorkMode(1, WorkMode) == 1)
	{
		
	}
	
}

void CISP_SDK_ExampleDlg::OnbtnSetExpTimeClick() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (MTUCISP_SetDeviceExposureTime(1, m_intExpTime) != -1)
	{
		MessageBox("Set ExpTime Succeeded");
	}
	else
	{
		MessageBox("Set ExpTime Failed");
	}
}

void CISP_SDK_ExampleDlg::OnbtnGainClick() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if( MTUCISP_SetDeviceCCDTotalGain(1, m_intCCDGain) ==1 )
	{
		MessageBox("Set CCD Gain Succeeded");
	}
	else
	{
		MessageBox("Set CCD Gain Failed");
	}
}

void CISP_SDK_ExampleDlg::OnbtnOptBlackClick() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if( MTUCISP_SetDeviceCCDOpticBlack(1, m_intOptBlack) ==1 )
	{
		MessageBox("Set Optical Black Succeeded");
	}
	else
	{
		MessageBox("Set Optical Black Failed");
	}
	
}

void CISP_SDK_ExampleDlg::OnbtnAvgNumClick() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if( MTUCISP_SetDeviceAverageFrameNum(1, m_intAvgNum) ==1 )
	{
		MessageBox("Set Avg Num Succeeded");
	}
	else
	{
		MessageBox("Set Avg Num Failed");
	}
	
}

void CISP_SDK_ExampleDlg::OncheckETCClick() 
{
	int ETCStatus;
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);

	if (m_boolETC == true)
	{
		ETCStatus = 1;
	}
	else
	{
		ETCStatus = 0;
	}

	MTUCISP_SetDeviceSpectrometerETCStatus(1, 1 , ETCStatus) ;

}

void CISP_SDK_ExampleDlg::OnbtnGrabOneClick() 
{
	// TODO: Add your control notification handler code here
	if (MTUCISP_StartFrameGrab( 1 ) == 1)
	{
		
	}
	else
	{
		
	}
}

void CISP_SDK_ExampleDlg::OnbtnGetDataClick() 
{
	// TODO: Add your control notification handler code here
	double *ptrdata;
	double tmpData[2448 * 6];
	double CalibData[2448];
	double DarkSubData[2448];
	double TvRData[2448];
	double CCDMin = 4096, DarkSubMin = 4096, TvRMin = 4096, CalibMin = 4096;
	double CCDMax = 0, DarkSubMax = 0, TvRMax = 0, CalibMax = 0;
	int i;

	if (MTUCISP_GetDeviceSpectrometerDisplayData( 1 , 1 , 1, ptrdata ) == 1)
	{
		for (i=0;i<6 * 2448;i++)
		{
			tmpData[i] = *ptrdata++;
		}

		for (i=0;i<2448;i++)
		{
			CCDData[i] = tmpData[i];
			if (CCDMin > CCDData[i])
			{
				CCDMin = CCDData[i];
			}
			if (CCDMax < CCDData[i])
			{
				CCDMax = CCDData[i];
			}
			
			CalibData[i] = tmpData[i+2448];
			if( CalibMin > CalibData[i])
			{
				CalibMin = CalibData[i];
			}
			if(CalibMax < CalibData[i])
			{
				CalibMax = CalibData[i];
			}

			DarkSubData[i] = tmpData[i+2448*2];
			if( DarkSubMin > DarkSubData[i])
			{
				DarkSubMin = DarkSubData[i];
			}
			if( DarkSubMax < DarkSubData[i])
			{
				DarkSubMax = DarkSubData[i];
			}

			TvRData[i] = tmpData[i+ 2448*3];
			if( TvRMin > TvRData[i])
			{
				TvRMin = TvRData[i];
			}
			if( TvRMax < TvRData[i])
			{
				TvRMax = TvRData[i];
			}
		}

		m_strMinCCD.Format("%f",CCDMin);
		m_strMaxCCD.Format("%f",CCDMax);
		m_strMinDarkSub.Format("%f",DarkSubMin);
		m_strMaxDarkSub.Format("%f",DarkSubMax);
		m_strMinTvR.Format("%f",TvRMin);
		m_strMaxTvR.Format("%f",TvRMax);
		m_strMinCalib.Format("%f",CalibMin);
		m_strMaxCalib.Format("%f",CalibMax);
		
		UpdateData(FALSE);

	}
	else
	{
		MessageBox("Get Data Failed");
	}


}
void FrameDataCallBack(TSpectrumDataProperty *Property, double **FloatPtr)
{

	//Property->AvgFrameCnt
	//Property->CameraID
	//Property->Column
	//Property->ExposureTime
	//Property->SliceNum
	//Property->FrameTime
	//Property->GreenGain
	//Property->OpticalBlack
	//Property->TimeStamp
	
	int i;
	int TimeStamp;
	double *ptrSpectro;
	double tmpCCDData[6][2448];
	double Min1 = 4096,Min2 = 4096,Min3 = 4096;
	double Max1 = 0,Max2 = 0,Max3 = 0;
	
	extern CISP_SDK_ExampleApp theApp;

	if(Property->CameraID == 1)
	{
		TimeStamp = Property->TimeStamp;
		
		((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strFrameTime.Format("%d",TimeStamp);	

		if( Property->SpectroNum >= 1) 
		{
			ptrSpectro = *FloatPtr++;	// the first spectrometer display data address;
			for(i=0;i<2448;i++)
			{
				CCDData[i] = *ptrSpectro++;

				if(CCDData[i] < Min1)
					Min1 = CCDData[i];

				if(CCDData[i] > Max1)
					Max1 = CCDData[i];
			}

			((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strMin1.Format("%f",Min1);
			((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strMax1.Format("%f",Max1);

		}
		
		if(Property->SpectroNum >= 2)
		{

			ptrSpectro = *FloatPtr++; // the second spectrometer
			for(i=0;i<2448;i++)
			{
				tmpCCDData[1][i] = *ptrSpectro++;

				if(tmpCCDData[1][i] < Min2)
					Min2 = tmpCCDData[1][i];

				if(tmpCCDData[1][i] > Max2)
					Max2 = tmpCCDData[1][i];

			}
			((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strMin2.Format("%f",Min2);
			((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strMax2.Format("%f",Max2);

		}

		if(Property->SpectroNum >= 3)
		{
			ptrSpectro = *FloatPtr;
			for(i=0;i<2448;i++)
			{
				tmpCCDData[2][i] = *ptrSpectro++;

				if(tmpCCDData[2][i] < Min3)
					Min3 = tmpCCDData[2][i];

				if(tmpCCDData[2][i] > Max3)
					Max3 = tmpCCDData[2][i];

			}
			((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strMin3.Format("%f",Min3);
			((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->m_strMax3.Format("%f",Max3);

		}

		((CISP_SDK_ExampleDlg *)theApp.m_pMainWnd)->UpdateData(FALSE);
	
	}

}

void CISP_SDK_ExampleDlg::OnbtnInstallCallBackClick() 
{
	// TODO: Add your control notification handler code here
	
	MTUCISP_InstallSpectrometerFrameHooker(1, FrameDataCallBack);
}

void CISP_SDK_ExampleDlg::OnbtnStartGrabClick() 
{
	// TODO: Add your control notification handler code here
	MTUCISP_StartFrameGrab(0x8888 );
}

void CISP_SDK_ExampleDlg::OnbtnStopGrabClick() 
{
	// TODO: Add your control notification handler code here
	MTUCISP_StopFrameGrab( );
}

void CISP_SDK_ExampleDlg::OnbtnSetDrkClick() 
{
	// TODO: Add your control notification handler code here
	MTUCISP_SetDeviceSpectrometerDarkData(1,1, CCDData);
}

void CISP_SDK_ExampleDlg::OnbtnSetRefClick() 
{
	// TODO: Add your control notification handler code here
	MTUCISP_SetDeviceSpectrometerRefData(1, 1, CCDData);	
}

void CISP_SDK_ExampleDlg::OnbtnGetWavClick() 
{
	// TODO: Add your control notification handler code here
	int Wavelength;
	UpdateData(TRUE);
	Wavelength = MTUCISP_GetDeviceSpectrometerWavValue(1, 1, m_intPixel);

	m_strWav.Format("%d",Wavelength);
	UpdateData(FALSE);
}

void CISP_SDK_ExampleDlg::OnbtnSpectrumClick() 
{
	// TODO: Add your control notification handler code here
	double VSpectrum[830-360+1];
	double S360,S555,S830;

	if(MTUCISP_GetDeviceSpectrometerSpectrum(1, 1, CCDData,VSpectrum) == 1)
	{
		S360 = VSpectrum[0];
		S555 = VSpectrum[555-360];
		S830 = VSpectrum[830-360];

		m_str360.Format("%f",S360);
		m_str555.Format("%f",S555);
		m_str830.Format("%f",S830);

		UpdateData(FALSE);
	}
	
}

void CISP_SDK_ExampleDlg::OnbtnCIEClick() 
{
	// TODO: Add your control notification handler code here
	double x = 0,y =0 ,u =0 ,v =0 ;
	int CCT = 0;

	MTUCISP_GetDeviceSpectrometerCIE1931Coords(1, 1, CCDData,x,y);
	MTUCISP_GetDeviceSpectrometerCIE1976Coords(1, 1, CCDData,u,v);
	MTUCISP_GetDeviceSpectrometerCCT(1, 1, CCDData,	CCT);
	m_strxy.Format("%0.4f,%0.4f",x,y);
	m_struv.Format("%0.4f,%0.4f",u,v);
	m_strCCT.Format("%d",CCT);

	UpdateData(FALSE);
}

void CISP_SDK_ExampleDlg::OnbtnCRIClick() 
{
	// TODO: Add your control notification handler code here
	double CRIs[15];

	MTUCISP_GetDeviceSpectrometerCRIs(1, 1, CCDData,CRIs); 
	m_strCRIa.Format("%f",CRIs[0]);

	UpdateData(FALSE);
}
