unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,strUtils,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, TeeProcs, TeEngine, Chart, Series;

type
  TForm1 = class(TForm)
    Button1: TButton;
    DeviceBox: TComboBox;
    Button2: TButton;
    Button3: TButton;
    DeviceInfo: TMemo;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    RGWorkMode: TRadioGroup;
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    EditET: TEdit;
    Button8: TButton;
    GroupBox3: TGroupBox;
    TrackGain: TTrackBar;
    GroupBox4: TGroupBox;
    TrackOB: TTrackBar;
    GroupBox5: TGroupBox;
    TrackAvgNum: TTrackBar;
    Bevel2: TBevel;
    StatusBar: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button10: TButton;
    SpectroBox: TComboBox;
    SpectroInfo: TMemo;
    RGETC: TRadioGroup;
    Button14: TButton;
    RadioGroup5: TRadioGroup;
    Chart1: TChart;
    Series1: TLineSeries;
    Button12: TButton;
    Button13: TButton;
    Button9: TButton;
    Button11: TButton;
    Memo1: TMemo;
    Label7: TLabel;

    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RGWorkModeClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure TrackGainChange(Sender: TObject);
    procedure TrackOBChange(Sender: TObject);
    procedure TrackAvgNumChange(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure RGETCClick(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure RadioGroup5Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);

  private
    { Private declarations }
    procedure ShowfalseOnStatusbar();
    procedure ShowTrueOnStatusbar();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FrameCnt:integer;

implementation
  uses MyDatatypes, myDllInterface;
{$R *.dfm}

  function IntToByteByRecursion(const Int:integer):integer;
  begin
    result := Int div 256;
    if result = 0 then
      result := Int
    else if result < 16 then
      result := Int div 16
    else if result >= 256 then
      result := IntToByteByRecursion(Result);
  end;

procedure DeviceFrameCallBack(ImageProperty : POutputDataProperty; FramePtr :array of PDouble ); cdecl;
begin
  Inc(FrameCnt);
  Form1.Label7.Caption := IntToStr(FrameCnt);
  if (FrameCnt mod 5 = 0) then
    begin
      Form1.Memo1.Clear;
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.CameraID));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.Column ));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.AvgFrameCnt));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.ExposureTime ));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.GreenGain));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.TimeStamp));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.OpticalBlack));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.FrameTime));
      Form1.Memo1.Lines.Add(IntToStr(ImageProperty^.SliceNum));

    end;
end;

procedure TForm1.ShowfalseOnStatusbar();
begin
  statusbar.Panels[0].Text := 'Command Fail';
end;

procedure TForm1.ShowTrueOnStatusbar();
begin
  StatusBar.Panels[0].Text :='Command Succeed';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i:integer;
  DeviceNum:integer;
  moduleNo,SerialNo:array[0..15] of Char;
begin
  DeviceNum := MTUCISP_InitDevice();
  if deviceNum >0 then
    begin
      deviceBox.Clear;
      for I := 1 to DeviceNum do    // Iterate
      begin
        MTUCISP_GetDeviceModuleNoSerialNo(i,moduleNo,SerialNo);
        deviceBox.Items.Add(IntToStr(i) + ':'
                            +Trim( String(ModuleNo))+'_'+Trim(String(SerialNo)));

      end;    // for

      DeviceBox.ItemIndex := 0;
    end;    
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  DeviceID:integer;
begin
  DeviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      if MTUCISP_AddDeviceToWorkingSet(DeviceID) = -1 then
        ShowfalseOnStatusbar
      else
        ShowTrueOnStatusbar;
    end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  DeviceID:integer;
begin
  DeviceID := DeviceBox.ItemIndex + 1;
  if deviceID > 0 then
    begin
      if MTUCISP_RemoveDeviceFromWorkingSet(DeviceID) = -1 then
        ShowfalseOnStatusbar
      else
       ShowTrueOnStatusbar;
    end;    
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  deviceID:integer;

begin
  DeviceInfo.Clear;
  DeviceID := DevicebOX.ItemIndex + 1;
  if DeviceID > 0 then
    begin
     MTUCISP_GetDeviceCCDSize(deviceID,@Deviceproperty.MaxCCDSize.RowNum);

     Deviceproperty.SliceNum := MTUCISP_GetDeviceSpectrometerNum(DeviceID);
     DeviceInfo.Lines.Add('MaxCCDSize:'+ IntToStr(Deviceproperty.MaxCCDSize.ColumnNum)
                         +'*'+IntToStr(Deviceproperty.MaxCCDSize.RowNum));
     DeviceInfo.Lines.Add('SLiceNum:'+IntToStr(Deviceproperty.SliceNum));

    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if MTUCISP_StartDeviceEngine() = -1 then
    ShowfalseOnStatusbar
  else
    ShowTrueOnStatusbar;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if MTUCISP_StopDeviceEngine() = -1 then
    ShowfalseOnStatusbar
  else
    ShowTrueOnStatusbar;    
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if MTUCISP_UnInitDevice() = -1 then
    ShowfalseOnStatusbar
  else
    ShowTrueOnStatusbar;
end;

procedure TForm1.RGWorkModeClick(Sender: TObject);
var
  deviceID:integer;
  workMode:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      workMode := RGWorkMode.ItemIndex;
      if MTUCISP_SetDeviceWorkMode(DeviceID,workMode) = -1 then
        begin
          RGWorkMode.ItemIndex := -1;
          ShowfalseOnStatusbar;
        end
      else
        ShowTrueOnStatusbar;
    end;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  ExpTime:integer;
  tmpCode:integer;
  DeviceID:integer;
  tmpResult:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      Val(EditET.Text,exptime,tmpCode);
      tmpResult :=MTUCISP_SetDeviceExposureTime(deviceID,exptime);
      if tmpResult= -1 then
        begin
          ShowfalseOnStatusbar;
          EditET.Text := IntToStr(-1);
        end
      else
        begin
          ShowTrueOnStatusbar;
          EditET.Text := IntToStr(tmpResult);
        end;
    end;
end;

procedure TForm1.TrackGainChange(Sender: TObject);
var
  deviceID:integer;
  CCDGain:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      CCDGain := trackGain.Position;
      if MTUCISP_SetDeviceCCDTotalGain(deviceID,CCDGain) = -1 then
        begin
          ShowfalseOnStatusbar;
        end
      else
        ShowTrueOnStatusbar;        
    end;
end;


procedure TForm1.TrackOBChange(Sender: TObject);
var
  deviceID:integer;
  OBVal:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      OBVal := trackOB.Position;
      if MTUCISP_SetDeviceCCDOpticBlack(deviceID,OBVal) = -1 then
        ShowfalseOnStatusbar
      else
        ShowTrueOnStatusbar;
    end;
end;

procedure TForm1.TrackAvgNumChange(Sender: TObject);
var
  deviceID:integer;
  AvgNum:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      AvgNum := TrackAvgNum.Position;
      if MTUCISP_SetDeviceAverageFrameNum(deviceID,AvgNum) = -1 then
        ShowfalseOnStatusbar
      else
        ShowTrueOnStatusbar;        
    end;
end;


procedure TForm1.Button12Click(Sender: TObject);
var
  deviceID:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
     if MTUCISP_StartFrameGrab(1) = -1 then
       ShowfalseOnStatusbar
     else
       ShowTrueOnStatusbar;
    end;
end;

procedure TForm1.Button13Click(Sender: TObject);
var
  deviceID:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      if MTUCISP_StopFrameGrab = -1 then
        ShowfalseOnStatusbar
      else
        ShowTrueOnStatusbar;
    end;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  deviceID:integer;
  SpectroNum:integer;
  i:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0 then
    begin
      SpectroNum := MTUCISP_GetDeviceSpectrometerNum(DeviceID);
      if  SpectroNum> 0 then
        begin
          SpectroProperty.MaxPixelPoints := Deviceproperty.MaxCCDSize.ColumnNum;
          SpectroBox.Clear;
          for I := 1 to SpectroNum do    // Iterate
          begin
            SpectroBox.Items.Add('Spectrometer:' + intToStr(i));
          end;    // for
          SpectroBox.ItemIndex := 0;
        end
      else if SpectroNum = 0 then
        begin
          SpectroBox.Clear;
          Spectrobox.Items.Add('No Spectrometer defined!');
          SpectroBox.ItemIndex := 0;
        end
      else
        begin
          ShowfalseOnStatusbar;
        end;
    end
  else
    begin
      ShowfalseOnStatusbar;
    end;
end;

procedure TForm1.RGETCClick(Sender: TObject);
var
  DeviceID:integer;
  SpectroID:integer;
  ETCStatus:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  SpectroID := SpectroBox.itemIndex + 1;
  if ((DeviceiD > 0) and (SpectroID > 0)) then
    begin
      ETCStatus:= RGETC.ItemIndex;
      if MTUCISP_SetDeviceSpectrometerETCStatus(deviceID,spectroID,ETCStatus) =-1 then
        begin
          RGETC.ItemIndex := -1;
          ShowfalseOnStatusbar;
        end
      else
        ShowTrueOnStatusbar;
    end;
end;


procedure TForm1.Button14Click(Sender: TObject);
var
  DeviceID:integer;
  SpectroID:integer;
  RRCStatus:integer;
  tmpPtrFloat:PDouble;
  i:integer;

begin
  deviceID := DeviceBox.ItemIndex + 1;
  SpectroID := SpectroBox.itemIndex + 1;
  if ((DeviceiD > 0) and (SpectroID > 0)) then
    begin
      MTUCISP_GetDeviceSpectrometerDisplayData(DeviceID,SpectroID, 1, tmpPtrFloat);

      if tmpPtrFloat <> nil then
        begin
          for i := 0 to MAX_CCD_POINTS-1 do
            begin
              OutputData.CCDData[i] := tmpPtrFloat^;
              Inc(tmpPtrFloat);

            end;

          for i := 0 to MAX_CCD_POINTS-1 do
            begin
              OutputData.CalibData[i] := tmpPtrFloat^;
              Inc(tmpPtrFloat);
            end;
          for i := 0 to MAX_CCD_POINTS-1 do
            begin
              OutputData.DarkSubData[i] := tmpPtrFloat^;
              Inc(tmpPtrFloat);
            end;
          for i := 0 to MAX_CCD_POINTS-1 do
            begin
              OutputData.ToverRData[i] := tmpPtrFloat^;
              Inc(tmpPtrFloat);
            end;
          for i := 0 to MAX_CCD_POINTS-1 do
            begin
              OutputData.AbsorbData[i] := tmpPtrFloat^;
              Inc(tmpPtrFloat);
            end;
          for i := 0 to MAX_CCD_POINTS-1 do
            begin
              OutputData.AbsIntenData[i] := tmpPtrFloat^;
              Inc(tmpPtrFloat);
            end;

          series1.Clear ;
          for I := 0 to spectroProperty.MaxPixelPoints-1 do    // Iterate
          begin
            Series1.AddXY(i,OutputData.CCDData[i]);
          end;    // for
            
        end;
    end;
end;

procedure TForm1.RadioGroup5Click(Sender: TObject);
var
  i:integer;
  index:integer;
  ptrCCDData:pCCDDataArray;
begin
  index := RadioGroup5.ItemIndex;
  case index of    //
    0: ptrCCDData := @(OutputData.CCDData);
    1: ptrCCDData := @(OutputData.CalibData);
    2: ptrCCDData := @(OutputData.DarkSubData);
    3: ptrCCDData := @(OutputData.ToverRData);
    4: ptrCCDData := @(OutputData.AbsorbData);
    5: ptrCCDData := @(OutputData.AbsIntenData);
  end;    // case
  Series1.Clear;
  for I := 0 to spectroProperty.MaxPixelPoints-1 do    // Iterate
  begin
    Series1.AddXY(i,ptrCCDData[i])
  end;    // for
end;


procedure TForm1.Button9Click(Sender: TObject);
var
  deviceID:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  FrameCnt := 0;
  if DeviceID > 0 then
    begin
     if MTUCISP_StartFrameGrab($8888) = -1 then
       ShowfalseOnStatusbar
     else
      begin
        ShowTrueOnStatusbar;
      end;
    end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  deviceID:integer;
begin
  deviceID := DeviceBox.ItemIndex + 1;
  if DeviceID > 0  then
    begin
      if ( Deviceproperty.SliceNum >0 ) then
        begin
          if MTUCISP_InstallDeviceFrameHooker(deviceID,DeviceFrameCallBack) <> -1 then
            ShowTrueOnStatusbar
          else
            ShowfalseOnStatusbar;
        end;
    end;
end;

end.
