unit MydllInterfacce;

interface
  uses
    Windows,
    myDatatypes;
  type
  POutputDataProperty = ^TOutputDataProperty;
  TOutputDataProperty = record
    CameraID     : integer;
    WorkMode     : integer;
    Row          : integer;
    Column       : integer;
//    Bin          : integer;
//    XStart       : integer;
//    YStart       : integer;
    ExposureTime : integer;
//    RedGain      : integer;
    GreenGain    : integer;
//    BlueGain     : integer;
//    TimeStamp    : integer;
//    TriggerOccurred  : integer;
//    TriggerEventCount: integer;
    OpticalBlack : integer; //OpticBlack: integer;
    FrameTime : integer;
//    CCDFrequency : integer;

//    ProcessFrameType : integer;
//    FilterAcceptForFile : integer;
    ExtraInfo    : integer; //usef for SpectroNum
  end;

  TDeviceFrameCallBack = procedure(ImageProperty : POutputDataProperty; FramePtr :array of PDouble ); cdecl;

  function MTUCISP_InitDevice():integer;cdecl;
  function MTUCISP_AddDeviceToWorkingSet(DeviceID:integer):integer;cdecl;
  function MTUCISP_RemoveDeviceFromWorkingSet(deviceID:integer):integer;cdecl;
  function MTUCISP_InstallDeviceFrameHooker(deviceID: integer;DeviceHookerProc:TDeviceFrameCallBack):integer;cdecl;
  function MTUCISP_StartDeviceEngine():integer;cdecl;
  function MTUCISP_StartFrameGrab():integer;cdecl;
  function MTUCISP_StopFrameGrab(): integer ; cdecl;
  function MTUCISP_StopDeviceEngine():integer;cdecl;
  function MTUCISP_UnInitDevice():integer;cdecl;

  function MTUCISP_GetDeviceModuleNoSeiralNo(DeviceId:integer;
                                  ModuleNo:Pchar; SerialNo:Pchar):integer;cdecl;
                                  
  function MTUCISP_GetDeviceProperty(DeviceID:integer;
                                   ptr:PInteger):integer;cdecl;

  function MTUCISP_GetDeviceType(DeviceId: integer):integer;cdecl;

  function MTUCISP_GetDeviceMinMaxExpTime(DeviceID:integer;
                                        var MinExp:integer;
                                        var MaxExp:integer):integer;cdecl;

  function MTUCISP_GetDeviceMinFrameTime(DeviceID:integer;
                                        var MinFrameTime:integer):integer;cdecl;

  function MTUCISP_GetDeviceCCDSize(DeviceID:integer;
                                  var ColNum:integer;
                                  var RowNum:integer):integer;cdecl;

  function MTUCISP_GetDeviceMaxBufferCount(DeviceID:integer):integer;cdecl;

  function MTUCISP_SetDevicesMinimumFrameDelayStatus(flag:integer):integer; cdecl;

  function MTUCISP_SetDevicesBitOption(Bit:integer):integer;cdecl;

  function MTUCISP_SetDeviceWorkMode(deviceID:integer;
                                   WorkMode:integer):integer;cdecl;

  function MTUCISP_SetDeviceExposureTime(deviceID:integer;
                                       ExpTime:integer):integer;cdecl;

  function MTUCISP_SetDeviceFrameTime(DeviceID:integer;
                                    FrameTIme:integer):integer;cdecl;

  function MTUCISP_SetDeviceBufferCount(deviceID:integer;BufferCnt:integer):integer;cdecl;

  function MTUCISP_SetDeviceCCDFrequency(DeviceID:integer;
                                       Frequency:integer):integer;cdecl;

  function MTUCISP_SetDeviceCCDTotalGain(DeviceID:integer;
                                       TotalGain:Integer):integer;cdecl;

  function MTUCISP_SetDeviceCCDOpticBlack(deviceId:Integer;
                                        OBValue:integer):integer;cdecl;

  function MTUCISP_SetDeviceGPIOConfig(deviceID:integer;Config:integer):integer;cdecl;

  function MTUCISP_SetDeviceGPIOInOut(DeviceID:integer;Input:integer):integer;cdecl;

  function MTUCISP_SetDeviceOperationMode(DeviceID:integer;
                                        OPMode:integer):integer;cdecl;

  function MTUCISP_SetDeviceAverageFrameNum(deviceID:integer;
                                          AvgFrameNum:integer):integer;cdecl;

  function MTUCISP_GetSpectrometerNumOfDevice(DeviceID:integer):integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerProperty(deviceID:integer;
                                         SpectroID:integer;
                                         ptr:PSpectrometerProperty):integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerWavCalPara(deviceID: integer;
                                      SpectroID:integer;
                                      ptr:PDouble):integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerETCCalPara(deviceID: integer;
                                         SpectroID:integer;
                                         ptr:PDouble):Integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerRRCCalPara(deviceID: integer;
                                         SpectroID:integer;
                                         ptr:PDouble):integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerAICCalPara(deviceID: integer;
                                   SpectroID:integer;
                                   var AICUnit:integer;
                                   ptr:PDouble):integer;cdecl;

//  MTUCISP_GetDeviceSpectrometerDarkStatus,
//  MTUCISP_SetDeviceSpectrometerDarkStatus,
  function MTUCISP_GetDeviceSpectrometerETCStatus(deviceID:integer;
                                                SpectroID:integer):integer;cdecl;
  function MTUCISP_SetDeviceSpectrometerETCStatus(deviceID:integer;
                                                   SpectroID:integer;
                                                   flag:integer):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerRRCStatus(deviceID:integer;
                                                  SpectroID:integer):integer;cdecl

  function MTUCISP_SetDeviceSpectrometerRRCStatus(deviceID:integer;
                                                flag:integer;
                                                SpectroID:integer):integer;cdecl;

  function MTUCISP_SaveDeviceSpectrometerAICCalPara(DeviceID:integer;
                                                  SpectroID:integer;
                                                  AICUnit:integer;
                                                  ptr:PDouble
                                                  ):integer;cdecl;
  function MTUCISP_SaveDeviceSpectrometerETCCalPara(DeviceID:integer;
                                                  SpectroID:integer;
                                                  ptr:PDouble
                                                  ):integer;cdecl;
  function MTUCISP_SaveDeviceSpectrometerRRCCalPara(DeviceID:integer;
                                                  SpectroID:integer;
                                                  ptr:PDouble
                                                  ):integer;cdecl;
  function MTUCISP_SaveDeviceSpectrometerWavCalPara(DeviceID:integer;
                                                  SpectroID:integer;
                                                  ptr:PDouble
                                                  ):integer;cdecl;


  //pure functions
  function MTUCISP_SetDeviceSpectrometerDarkData(deviceID:integer;
                                               spectroID:integer;
                                               ptrData:pDouble):integer;cdecl;
  function MTUCISP_SetDeviceSpectrometerRefData(deviceID:integer;
                                              spectroID:integer;
                                              ptrData:PDouble):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerDisplayData(deviceID:integer;
                                                  SpectroID:integer):PDouble;cdecl;
  function MTUCISP_GetDeviceSpectrometerWavValue(deviceID:integer;
                                               spectroID:integer;
                                               PixelNo:integer):Double;cdecl;
  function MTUCISP_GetDeviceSpectrometerSpectrum(deviceID:integer;
                                               spectroID:integer;
                                               ptrData:PDouble):PDouble;cdecl;
  function MTUCISP_GetDeviceSpectrometerCIE1931Coords(deviceID:integer;
                                                   SpectroID:integer;
                                                   ptrData:pDouble;
                                                   var x:Double;
                                                   var y:Double):integer;cdecl
  function MTUCISP_GetDeviceSpectrometerCIE1976Coords(deviceID:integer;
                                                   SpectroID:integer;
                                                   ptrData:pDouble;
                                                   var x:Double;
                                                   var y:Double):integer;cdecl
  function MTUCISP_GetDeviceSpectrometerCCT(deviceID:integer;
                                          SpectroID:integer;
                                          ptrData:pDouble;
                                          var CCT:integer):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerCRIs(deviceID:integer;
                                           SpectroID:integer;
                                           ptrData:pDouble):PDouble;cdecl
implementation
function MTUCISP_InitDevice;external 'MT_UCISP_SDK.dll' name 'MTUCISP_InitDevice';
function MTUCISP_AddDeviceToWorkingSet;external 'MT_UCISP_SDK.dll' name 'MTUCISP_AddDeviceToWorkingSet';
function MTUCISP_RemoveDeviceFromWorkingSet;external 'MT_UCISP_SDK.dll' name 'MTUCISP_RemoveDeviceFromWorkingSet';
function MTUCISP_InstallDeviceFrameHooker;external 'MT_UCISP_SDK.dll' name 'MTUCISP_InstallDeviceFrameHooker';
function MTUCISP_StartDeviceEngine;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StartDeviceEngine';
function MTUCISP_StartFrameGrab;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StartFrameGrab';
function MTUCISP_StopFrameGrab;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StopFrameGrab';
function MTUCISP_StopDeviceEngine;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StopDeviceEngine';
function MTUCISP_UnInitDevice;external 'MT_UCISP_SDK.dll' name 'MTUCISP_UnInitDevice';

function MTUCISP_GetDeviceModuleNoSeiralNo;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceModuleNoSeiralNo';
function MTUCISP_GetDeviceProperty;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceProperty';
function MTUCISP_GetDeviceType;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceType';
function MTUCISP_GetDeviceMinMaxExpTime;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceMinMaxExpTime';
function MTUCISP_GetDeviceMinFrameTime;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceMinFrameTime';
function MTUCISP_GetDeviceCCDSize;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceCCDSize';
function MTUCISP_GetDeviceMaxBufferCount;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceMaxBufferCount';
						
function MTUCISP_SetDevicesMinimumFrameDelayStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDevicesMinimumFrameDelayStatus';
function MTUCISP_SetDevicesBitOption;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDevicesBitOption';
function MTUCISP_SetDeviceWorkMode;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceWorkMode';
function MTUCISP_SetDeviceExposureTime;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceExposureTime';
function MTUCISP_SetDeviceFrameTime;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceFrameTime';
function MTUCISP_SetDeviceBufferCount;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceBufferCount';
function MTUCISP_SetDeviceCCDFrequency;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceCCDFrequency';
function MTUCISP_SetDeviceCCDTotalGain;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceCCDTotalGain';
function MTUCISP_SetDeviceCCDOpticBlack;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceCCDOpticBlack';
function MTUCISP_SetDeviceGPIOConfig;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceGPIOConfig';
function MTUCISP_SetDeviceGPIOInOut;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceGPIOInOut';
function MTUCISP_SetDeviceOperationMode;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceOperationMode';
function MTUCISP_SetDeviceAverageFrameNum;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceAverageFrameNum';

function MTUCISP_GetSpectrometerNumOfDevice;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetSpectrometerNumOfDevice';
function MTUCISP_GetDeviceSpectrometerProperty;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerProperty';
function MTUCISP_GetDeviceSpectrometerWavCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerWavCalPara';
function MTUCISP_GetDeviceSpectrometerETCCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerETCCalPara';
function MTUCISP_GetDeviceSpectrometerRRCCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerRRCCalPara';
function MTUCISP_GetDeviceSpectrometerAICCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerAICCalPara';
						
//  MTUCISP_GetDeviceSpectrometerDarkStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerDarkStatus';
//  MTUCISP_SetDeviceSpectrometerDarkStatus';						"//  MTUCISP_SetDeviceSpectrometerDarkStatus';
function MTUCISP_GetDeviceSpectrometerETCStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerETCStatus';
function MTUCISP_SetDeviceSpectrometerETCStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerETCStatus';
function MTUCISP_GetDeviceSpectrometerRRCStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerRRCStatus';
function MTUCISP_SetDeviceSpectrometerRRCStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerRRCStatus';
						
function MTUCISP_SaveDeviceSpectrometerAICCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SaveDeviceSpectrometerAICCalPara';
function MTUCISP_SaveDeviceSpectrometerETCCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SaveDeviceSpectrometerETCCalPara';
function MTUCISP_SaveDeviceSpectrometerRRCCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SaveDeviceSpectrometerRRCCalPara';
function MTUCISP_SaveDeviceSpectrometerWavCalPara;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SaveDeviceSpectrometerWavCalPara';
						
						
  //pure functions						  //pure functions
function MTUCISP_SetDeviceSpectrometerDarkData;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerDarkData';
function MTUCISP_SetDeviceSpectrometerRefData;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerRefData';
function MTUCISP_GetDeviceSpectrometerDisplayData;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerDisplayData';
function MTUCISP_GetDeviceSpectrometerWavValue;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerWavValue';
function MTUCISP_GetDeviceSpectrometerSpectrum;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerSpectrum';
function MTUCISP_GetDeviceSpectrometerCIE1931Coords;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCIE1931Coords';
function MTUCISP_GetDeviceSpectrometerCIE1976Coords;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCIE1976Coords';
function MTUCISP_GetDeviceSpectrometerCCT;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCCT';
function MTUCISP_GetDeviceSpectrometerCRIs;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCRIs';

end.
