unit MydllInterface;

interface
  uses
    Windows,
    myDatatypes;
  type
  
  POutputDataProperty = ^TOutputDataProperty;
  TOutputDataProperty = record
    CameraID     : integer;
    Column       : integer;
    AvgFrameCnt  : integer;//Row          : integer;
    ExposureTime : integer;
    GreenGain    : integer;
    TimeStamp    : integer;
    OpticalBlack : integer; //OpticBlack: integer;
    FrameTime   : integer;
    SliceNum    : integer; //usef for SpectroNum
  end;

  TDeviceFrameCallBack = procedure(ImageProperty : POutputDataProperty; FramePtr :array of PDouble ); cdecl;

  function MTUCISP_InitDevice():integer;cdecl;
  function MTUCISP_AddDeviceToWorkingSet(DeviceID:integer):integer;cdecl;
  function MTUCISP_RemoveDeviceFromWorkingSet(deviceID:integer):integer;cdecl;
  function MTUCISP_InstallDeviceFrameHooker(deviceID: integer;DeviceHookerProc:TDeviceFrameCallBack):integer;cdecl;
  function MTUCISP_StartDeviceEngine():integer;cdecl;
  function MTUCISP_StartFrameGrab(GrabType:integer):integer;cdecl;
  function MTUCISP_StopFrameGrab(): integer ; cdecl;
  function MTUCISP_StopDeviceEngine():integer;cdecl;
  function MTUCISP_UnInitDevice():integer;cdecl;


  function MTUCISP_GetDeviceModuleNoSerialNo(DeviceId:integer;
                                  ModuleNo:PChar; SerialNo:PChar):integer;cdecl;
  function MTUCISP_GetDeviceCCDSize(DeviceID:integer;PtrInt: PInteger):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerNum(DeviceID:integer):integer;cdecl;


  function MTUCISP_SetDeviceWorkMode(deviceID:integer;
                                   WorkMode:integer):integer;cdecl;
  function MTUCISP_SetDeviceExposureTime(deviceID:integer;
                                       ExpTime:integer):integer;cdecl;
  function MTUCISP_SetDeviceCCDTotalGain(DeviceID:integer;
                                       TotalGain:Integer):integer;cdecl;
  function MTUCISP_SetDeviceCCDOpticBlack(deviceId:Integer;
                                        OBValue:integer):integer;cdecl;
  function MTUCISP_SetDeviceAverageFrameNum(deviceID:integer;
                                          AvgFrameNum:integer):integer;cdecl;


  function MTUCISP_GetDeviceSpectrometerETCStatus(deviceID:integer;
                                                SpectroID:integer):integer;cdecl;
  function MTUCISP_SetDeviceSpectrometerETCStatus(deviceID:integer;
                                                   SpectroID:integer;
                                                   flag:integer):integer;cdecl;




  function MTUCISP_GetDeviceSpectrometerDisplayData(deviceID:integer;
                                                  SpectroID:integer;
                                                  WaitUntilDone:integer;
                                                  var PtrData:PDouble):integer;cdecl;
  function MTUCISP_SetDeviceSpectrometerDarkData(deviceID:integer;
                                                  spectroID:integer;
                                                  ptrData:pDouble):integer;cdecl;
  function MTUCISP_SetDeviceSpectrometerRefData(deviceID:integer;
                                              spectroID:integer;
                                              ptrData:PDouble):integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerWavValue(deviceID:integer;
                                               spectroID:integer;
                                               PixelNo:integer):Integer;cdecl;

  function MTUCISP_GetDeviceSpectrometerSpectrum(DeviceNo:integer;
                                               spectroID:integer;
                                               ptrInput:PDouble;
                                               ptrOutput:PDouble):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerCIE1931Coords(deviceID:integer;
                                                   SpectroID:integer;
                                                   ptrData:pDouble;
                                                   var x:Double;
                                                   var y:Double):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerCIE1976Coords(DeviceNo:integer;
                                                   SpectroID:integer;
                                                   ptrData:pDouble;
                                                   var x:Double;
                                                   var y:Double):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerCCT(DeviceNo:integer;
                                           SpectroID:integer;
                                           ptrData:pDouble;
                                           ptrCRIs:PDouble):integer;cdecl;
  function MTUCISP_GetDeviceSpectrometerCRIs(DeviceNo:integer;
                                           SpectroID:integer;
                                           ptrData:pDouble;
                                           ptrCRIs:PDouble):integer;cdecl;
implementation
function MTUCISP_InitDevice;external 'MT_UCISP_SDK.dll' name 'MTUCISP_InitDevice';
function MTUCISP_AddDeviceToWorkingSet;external 'MT_UCISP_SDK.dll' name 'MTUCISP_AddDeviceToWorkingSet';
function MTUCISP_RemoveDeviceFromWorkingSet;external 'MT_UCISP_SDK.dll' name 'MTUCISP_RemoveDeviceFromWorkingSet';
function MTUCISP_InstallDeviceFrameHooker;external 'MT_UCISP_SDK.dll' name 'MTUCISP_InstallDeviceFrameHooker';
function MTUCISP_StartDeviceEngine;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StartDeviceEngine';
function MTUCISP_StartFrameGrab;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StartFrameGrab';
function MTUCISP_StopFrameGrab;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StopFrameGrab';
function MTUCISP_StopDeviceEngine;external 'MT_UCISP_SDK.dll' name 'MTUCISP_StopDeviceEngine';
function MTUCISP_UnInitDevice;external 'MT_UCISP_SDK.dll' name 'MTUCISP_UnInitDevice';

function MTUCISP_GetDeviceModuleNoSerialNo;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceModuleNoSerialNo';
function MTUCISP_GetDeviceCCDSize;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceCCDSize';
function MTUCISP_GetDeviceSpectrometerNum;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerNum';

function MTUCISP_SetDeviceWorkMode;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceWorkMode';
function MTUCISP_SetDeviceExposureTime;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceExposureTime';
function MTUCISP_SetDeviceCCDTotalGain;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceCCDTotalGain';
function MTUCISP_SetDeviceCCDOpticBlack;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceCCDOpticBlack';
function MTUCISP_SetDeviceAverageFrameNum;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceAverageFrameNum';

function MTUCISP_GetDeviceSpectrometerETCStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerETCStatus';
function MTUCISP_SetDeviceSpectrometerETCStatus;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerETCStatus';


						
  //pure functions						  //pure functions
function MTUCISP_SetDeviceSpectrometerDarkData;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerDarkData';
function MTUCISP_SetDeviceSpectrometerRefData;external 'MT_UCISP_SDK.dll' name 'MTUCISP_SetDeviceSpectrometerRefData';
function MTUCISP_GetDeviceSpectrometerDisplayData;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerDisplayData';
function MTUCISP_GetDeviceSpectrometerWavValue;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerWavValue';
function MTUCISP_GetDeviceSpectrometerSpectrum;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerSpectrum';
function MTUCISP_GetDeviceSpectrometerCIE1931Coords;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCIE1931Coords';
function MTUCISP_GetDeviceSpectrometerCIE1976Coords;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCIE1976Coords';
function MTUCISP_GetDeviceSpectrometerCCT;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCCT';
function MTUCISP_GetDeviceSpectrometerCRIs;external 'MT_UCISP_SDK.dll' name 'MTUCISP_GetDeviceSpectrometerCRIs';

end.
